#include <GUIConstantsEx.au3>
#include <MsgBoxConstants.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>

Global $bInOneGui = False

_main()

Func _guiCreate()
	Local Const $arBtnDefs = [ _
								["Pegasos 2", "pics/PegasosII.ico", "Pegasos_II.bat", true, Default], _
								["AmigaOne", "pics/AmigaOne.ico", "AmigaOne.bat", true, "Example.txt"], _
								["Sam460ex", "pics/Sam460ex.ico", "Sam460.bat", true, Default] _
							 ]
	Local $mGui[], $arButtonCtrlIds[UBound($arBtnDefs)][3]
	$mGui.btnDef = $arBtnDefs

	Local $iWidth = 300, $iHeight = 130+UBound($arBtnDefs)*50
	$mGui.hGui = GUICreate("AmigaNG Starter v0.2", $iWidth, $iHeight)
	GuiSetIcon("pics/amigaos.ico", 0)
	;BACKGROUND PIC
	;GuiCtrlCreatePic("pics/boingball.jpg", -1, -1, 300, 280)

	Local $sName = FileGetVersion( "qemu-system-ppc.exe", "ProductName")
	GUICtrlCreateLabel($sName<>""?$sName:"QEMU", 112, 15, 71, 31)
	Local $sVersion = FileGetVersion( "qemu-system-ppc.exe", "ProductVersion")
	GUICtrlCreateLabel($sVersion<>""?$sVersion:"- Not installed", 149, 15, 71, 31)

	; start create vm buttons
	For $i=0 to UBound($arBtnDefs)-1 Step 1
		Local $iTop = 50*($i+1)
		$arButtonCtrlIds[$i][0] = GUICtrlCreateButton($arBtnDefs[$i][0], 15, $iTop, 164, 34, $BS_ICON)
		GUICtrlSetImage($arButtonCtrlIds[$i][0], $arBtnDefs[$i][1])
		If $arBtnDefs[$i][3] Then $arButtonCtrlIds[$i][1] = GUICtrlCreateButton ("Edit", 185, $iTop+2, 50, 30)
		If $arBtnDefs[$i][4]<>Default Then $arButtonCtrlIds[$i][2] = GUICtrlCreateButton ("Example", 237, $iTop+2, 50, 30)
	Next
	$mGui.buttons = $arButtonCtrlIds
	; end create vm buttons

	;Start Create Image Buttons
	If $bInOneGui Then
		Local $iImageTop = $iHeight-50
		GUICtrlCreateLabel("Create HDD Image:", 25, $iImageTop-20)
		$mGui.inputRam = GUICtrlCreateInput('2048', 25, $iImageTop, 50, 20)
		GUICtrlCreateLabel("MB", 80, $iImageTop+5)
		$mGui.inputPathQemu = GUICtrlCreateInput('', 115, $iImageTop, 50, 20)
		$mGui.buttonPath = GUICtrlCreateButton("...", 170, $iImageTop, 40, 20)
		$mGui.buttonOk = GUICtrlCreateButton("OK",  215, $iImageTop, 40, 20)
	Else
		$mGui.buttonImageGui = GUICtrlCreateButton("Create Image", 10, $iHeight-55, $iWidth-20, 25)

		Local $iGuiImageWidth = 400, $iGuiImageHeight = 80, $mImageGui[]
		$mImageGui.hGui = GUICreate("Create HDD Image", $iGuiImageWidth, $iGuiImageHeight) ; create controls on the new gui now
		Local $iTop = 10
		$mImageGui.inputRam = GUICtrlCreateInput('2048', 10, $iTop, 50, 20)
		GUICtrlCreateLabel("MB", 65, $iTop+5)
		$iTop+=30
		$mImageGui.inputPathQemu = GUICtrlCreateInput('hdf\amiga.img', 10, $iTop, $iGuiImageWidth-120, 20)
		$mImageGui.buttonPath = GUICtrlCreateButton("...", $iGuiImageWidth-100, $iTop, 40, 20)
		$mImageGui.buttonOk = GUICtrlCreateButton("OK",  $iGuiImageWidth-50, $iTop, 40, 20)

		$mGui.imageGui = $mImageGui
		GUISwitch($mGui.hGui) ; Create controls after this line on the main gui again
	EndIf
	;End Create Image Buttons

	$mGui.menuFile = GUICtrlCreateMenu("&QEmu")
	$mGui.menuExit = GUICtrlCreateMenuItem("Exit", $mGui.menuFile)
	$mGui.menuHelp = GUICtrlCreateMenu("?")
	$mGui.menuInfo = GUICtrlCreateMenuItem("Info", $mGui.menuHelp)
	GUISetState(@SW_SHOW, $mGui.hGui)
	return $mGui
EndFunc

Func _main()
	Local $mGui = _guiCreate()
	Local $iMsg = 0
	While 1
		$arMsg = GUIGetMsg(1)
		; Handle input on the main gui
		If $arMsg[1] = $mGui.hGui Then
			Switch $arMsg[0]
				Case $GUI_EVENT_CLOSE, $mGui.menuExit
					ExitLoop
				Case $mGui.menuInfo
					MsgBox($MB_SYSTEMMODAL, "Info", "AmigaNG Starter v0.2" & @CRLF & @CRLF & "by Falke_34")
				Case $mGui.buttonPath
					GUICtrlSetData($mGui.imageGui.inputPathQemu, _imageSelectPath($mGui.hGui))
				Case $mGui.buttonImageGui
					GUISetState(@SW_SHOW, $mGui.imageGui.hGui)
				Case $mGui.buttonOk
					_imageCreate(Int(GUICtrlRead($mGui.inputRam)), GUICtrlRead($mGui.inputPathQemu))
					If @error Then MsgBox(16, "Error creating image", "Error: "&@error&" Ext: "&@extended)
			EndSwitch
			; Check if one of the buttons from our array was clicked and handle that
			If $arMsg[0]<>0 Then
				For $i=0 to UBound($mGui.buttons)-1 Step 1
					For $j=0 to UBound($mGui.buttons, 2)-1 Step 1
						If $arMsg[0]=$mGui.buttons[$i][$j] Then
							Local $subIndex = ($j=0 or $j=1)?2:4
							If $j=0 Then _run($mGui.btnDef[$i][$subIndex])
							If $j=1 Then _edit($mGui.btnDef[$i][$subIndex])
							If $j=2 Then _edit($mGui.btnDef[$i][$subIndex])
							Local $iError = @error
							Local $iExt = @extended
							If $iError Then MsgBox(16, "Error executing code", "Error running/editing/showing """&$mGui.btnDef[$i][$subIndex]&""" Error: "&$iError&" Ext: "&$iExt)
							ExitLoop
						EndIf
					Next
				Next
			EndIf
		EndIf
		; Handle input on the image gui
		If $arMsg[1] = $mGui.imageGui.hGui Then
			Switch $arMsg[0]
				Case $GUI_EVENT_CLOSE
					GUISetState(@SW_HIDE, $mGui.imageGui.hGui)
					GUICtrlSetData($mGui.imageGui.inputPathQemu, "")
				Case $mGui.imageGui.buttonPath
					GUICtrlSetData($mGui.imageGui.inputPathQemu, _imageSelectPath($mGui.imageGui.hGui))
				Case $mGui.imageGui.buttonOk
					_imageCreate(Int(GUICtrlRead($mGui.imageGui.inputRam)), GUICtrlRead($mGui.imageGui.inputPathQemu))
					If @error Then
						MsgBox(16, "Error creating image", "Error: "&@error&" Ext: "&@extended)
					Else
						GUISetState(@SW_HIDE, $mGui.imageGui.hGui)
						GUICtrlSetData($mGui.imageGui.inputPathQemu, "")
					EndIf
			EndSwitch
		EndIf
	WEnd
EndFunc

Func _run($sFile)
	Run($sFile)
	If @error Then return SetError(1, @error, False)
	return True
EndFunc

Func _edit($sFile)
	Run("notepad.exe "&$sFile)
	If @error Then return SetError(1, @error, False)
	return True
EndFunc

Func _imageSelectPath($hGui = 0, $sStartFolder=@ScriptDir)
	Local $sFolder = FileSelectFolder("Select folder", $sStartFolder, 0, "", $hGui)
	If @error or $sFolder="" Then return SetError(1, 0, "")
	return $sFolder
EndFunc

Func _imageCreate($iRam, $sPath)
	If $iRam<1 Then return SetError(1, 0, False)
	If $sPath="" Then return SetError(2, 0, False)
	Local $sCommand = 'qemu-img.exe create -f raw "'&$sPath&'" '&$iRam&'M'
	ConsoleWrite("Execute: "&$sCommand&@crlf)
	Run($sCommand, @ScriptDir)
	If @error Then Return SetError(3, @extended, False)
	return True
EndFunc